"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var TabSet_1 = require("./TabSet");
var Layout = /** @class */ (function (_super) {
    __extends(Layout, _super);
    function Layout(props) {
        var _this = _super.call(this, props) || this;
        _this.componentDidMount = function () {
            if (_this.ref.current) {
                var _a = _this.ref.current.getBoundingClientRect(), width = _a.width, height = _a.height;
                var rect = {
                    x: 0,
                    y: 0,
                    width: width,
                    height: height
                };
                _this.setState({ rect: rect });
            }
        };
        _this.renderChildren = function () {
            var children = _this.props.model.layout.children;
            var totalWeight = calcTotalWeight(children);
            var p = 0;
            return children.map(function (child, i) {
                var currentWidth = 0;
                if (totalWeight !== 0) {
                    currentWidth = Math.floor(_this.state.rect.width * (child.weight / totalWeight));
                }
                // TODO: think about adjusting sizes to exactly fit the screen
                // e.g. if totalSizeGiven < pixelSize (= parentRect.width)
                var rect = {
                    x: _this.state.rect.x + p,
                    y: _this.state.rect.y,
                    width: currentWidth,
                    height: _this.state.rect.height
                };
                p += currentWidth;
                switch (child.type) {
                    case "row":
                        return React.createElement("h1", null, "Row");
                    case "tabset":
                        return (React.createElement(TabSet_1.TabSet, { key: "tabset-" + i, id: i, rect: rect, selected: child.selected, isActive: _this.state.activeTabSet && _this.state.activeTabSet.id === child.id, onTabButtonClicked: _this.handleTabButtonClicked }, child.children));
                }
            });
        };
        _this.handleTabButtonClicked = function (id) {
            var newModel = __assign({}, _this.state.model);
            newModel.layout.children.forEach(function (child) {
                if (child.type === "tabset") {
                    var idx_1 = child.selected;
                    child.children.forEach(function (tab, i) {
                        if (tab.id === id) {
                            idx_1 = i;
                            _this.setState({ activeTabSet: child });
                        }
                    });
                    child.selected = idx_1;
                }
            });
            _this.setState({ model: newModel });
        };
        _this.ref = React.createRef();
        _this.state = {
            rect: { x: 0, y: 0, width: 0, height: 0 },
            model: props.model,
            activeTabSet: undefined
        };
        return _this;
    }
    Layout.prototype.render = function () {
        return (
        // FIXME: cannot use styled element with ref
        // maybe forwardRef solves the issue
        React.createElement("div", { ref: this.ref, style: {
                left: 0,
                top: 0,
                right: 0,
                bottom: 0,
                position: "absolute",
                overflow: "hidden"
            } }, this.renderChildren()));
    };
    return Layout;
}(React.Component));
exports.Layout = Layout;
function calcTotalWeight(nodes) {
    return nodes.reduce(function (totalWeight, node) { return (totalWeight += node.weight); }, 0);
}
//# sourceMappingURL=Layout.js.map