import Rect from "./Rect";
import Orientation from "./Orientation";
import { JSMap } from "./Types";
declare class DockLocation {
    static values: JSMap<DockLocation>;
    static TOP: DockLocation;
    static BOTTOM: DockLocation;
    static LEFT: DockLocation;
    static RIGHT: DockLocation;
    static CENTER: DockLocation;
    /** @hidden @internal */
    _name: string;
    /** @hidden @internal */
    _orientation: Orientation;
    /** @hidden @internal */
    _indexPlus: number;
    /** @hidden @internal */
    constructor(name: string, orientation: Orientation, indexPlus: number);
    getName(): string;
    getOrientation(): Orientation;
    /** @hidden @internal */
    static getByName(name: string): DockLocation;
    /** @hidden @internal */
    static getLocation(rect: Rect, x: number, y: number): DockLocation;
    /** @hidden @internal */
    getDockRect(r: Rect): Rect;
    /** @hidden @internal */
    split(rect: Rect, size: number): {
        start: Rect;
        end: Rect;
    };
    /** @hidden @internal */
    reflect(): DockLocation;
    toString(): string;
}
export default DockLocation;
