import Orientation from "./Orientation";
import { JSMap } from "./Types";
declare class Rect {
    x: number;
    y: number;
    width: number;
    height: number;
    constructor(x: number, y: number, width: number, height: number);
    static empty(): Rect;
    clone(): Rect;
    equals(rect: Rect): boolean;
    getBottom(): number;
    getRight(): number;
    positionElement(element: HTMLElement): void;
    styleWithPosition(style: JSMap<any>): JSMap<any>;
    contains(x: number, y: number): boolean;
    removeInsets(insets: {
        top: number;
        left: number;
        bottom: number;
        right: number;
    }): Rect;
    centerInRect(outerRect: Rect): void;
    /** @hidden @internal */
    _getSize(orientation: Orientation): number;
    toString(): string;
}
export default Rect;
