import Node from "./Node";
import Model from "./Model";
import Rect from "../Rect";
import DockLocation from "../DockLocation";
import Orientation from "../Orientation";
import DropInfo from "../DropInfo";
import TabNode from "./TabNode";
import SplitterNode from "./SplitterNode";
import AttributeDefinitions from "../AttributeDefinitions";
import IDropTarget from "./IDropTarget";
import IDraggable from "./IDraggable";
declare class BorderNode extends Node implements IDropTarget {
    static readonly TYPE = "border";
    /** @hidden @internal */
    private static _attributeDefinitions;
    /** @hidden @internal */
    private _contentRect?;
    /** @hidden @internal */
    private _tabHeaderRect?;
    /** @hidden @internal */
    private _location;
    /** @hidden @internal */
    private _drawChildren;
    /** @hidden @internal */
    private _adjustedSize;
    /** @hidden @internal */
    constructor(location: DockLocation, json: any, model: Model);
    getLocation(): DockLocation;
    getTabHeaderRect(): Rect | undefined;
    getContentRect(): Rect | undefined;
    isEnableDrop(): boolean;
    getClassName(): string | undefined;
    getBorderBarSize(): number;
    getSize(): number;
    getSelected(): number;
    getSelectedNode(): Node | undefined;
    getOrientation(): Orientation;
    isMaximized(): boolean;
    isShowing(): boolean;
    /** @hidden @internal */
    _setSelected(index: number): void;
    /** @hidden @internal */
    _setSize(pos: number): void;
    /** @hidden @internal */
    _updateAttrs(json: any): void;
    /** @hidden @internal */
    _getDrawChildren(): Node[];
    /** @hidden @internal */
    _setAdjustedSize(size: number): void;
    /** @hidden @internal */
    _getAdjustedSize(): number;
    /** @hidden @internal */
    _layoutBorderOuter(outer: Rect): Rect;
    /** @hidden @internal */
    _layoutBorderInner(inner: Rect): Rect;
    /** @hidden @internal */
    _remove(node: TabNode): void;
    /** @hidden @internal */
    canDrop(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
    /** @hidden @internal */
    drop(dragNode: Node & IDraggable, location: DockLocation, index: number): void;
    /** @hidden @internal */
    _toJson(): any;
    /** @hidden @internal */
    static _fromJson(json: any, model: Model): BorderNode;
    /** @hidden @internal */
    _getSplitterBounds(splitter: SplitterNode): number[];
    /** @hidden @internal */
    _calculateSplit(splitter: SplitterNode, splitterPos: number): number;
    /** @hidden @internal */
    _getAttributeDefinitions(): AttributeDefinitions;
    /** @hidden @internal */
    private static _createAttributeDefinitions;
}
export default BorderNode;
