import Rect from "../Rect";
import Model from "./Model";
import BorderNode from "./BorderNode";
import Node from "./Node";
import DropInfo from "../DropInfo";
import IDraggable from "./IDraggable";
declare class BorderSet {
    /** @hidden @internal */
    private _model;
    /** @hidden @internal */
    private _borders;
    /** @hidden @internal */
    constructor(model: Model);
    getBorders(): BorderNode[];
    /** @hidden @internal */
    _forEachNode(fn: (node: Node, level: number) => void): void;
    /** @hidden @internal */
    _toJson(): any[];
    /** @hidden @internal */
    static _fromJson(json: any, model: Model): BorderSet;
    /** @hidden @internal */
    _layoutBorder(outerInnerRects: {
        inner: Rect;
        outer: Rect;
    }): {
        inner: Rect;
        outer: Rect;
    };
    /** @hidden @internal */
    _findDropTargetNode(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
}
export default BorderSet;
