import AttributeDefinitions from "../AttributeDefinitions";
import DropInfo from "../DropInfo";
import Orientation from "../Orientation";
import Rect from "../Rect";
import { JSMap } from "../Types";
import IDraggable from "./IDraggable";
import Model from "./Model";
declare abstract class Node {
    protected _model: Model;
    protected _attributes: JSMap<any>;
    protected _parent?: Node;
    protected _children: Array<Node>;
    protected _fixed: boolean;
    protected _rect: Rect;
    protected _visible: boolean;
    protected _listeners: JSMap<(params: any) => void>;
    protected _dirty: boolean;
    protected _tempSize: number;
    protected constructor(model: Model);
    protected _getAttributeAsStringOrUndefined(attr: string): string | undefined;
    protected _getAttributeAsNumberOrUndefined(attr: string): number | undefined;
    getId(): string;
    getModel(): Model;
    getType(): string;
    getParent(): Node | undefined;
    getChildren(): Node[];
    getRect(): Rect;
    isVisible(): boolean;
    getOrientation(): Orientation;
    setEventListener(event: string, callback: (params: any) => void): void;
    removeEventListener(event: string): void;
    _setId(id: string): void;
    _fireEvent(event: string, params: any): void;
    _getAttr(name: string): any;
    _forEachNode(fn: (node: Node, level: number) => void, level: number): void;
    _setVisible(visible: boolean): void;
    _getDrawChildren(): Array<Node> | undefined;
    _setParent(parent: Node): void;
    _setRect(rect: Rect): void;
    _setWeight(weight: number): void;
    _setSelected(index: number): void;
    _isFixed(): boolean;
    _layout(rect: Rect): void;
    _findDropTargetNode(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
    canDrop(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
    _canDockInto(dragNode: Node & IDraggable, dropInfo: DropInfo | undefined): boolean;
    _removeChild(childNode: Node): number;
    _addChild(childNode: Node, pos?: number): number;
    _removeAll(): void;
    _styleWithPosition(style?: JSMap<any>): JSMap<any>;
    _getTempSize(): number;
    _setTempSize(value: number): void;
    isEnableDivide(): boolean;
    _toAttributeString(): string;
    abstract _updateAttrs(json: any): void;
    abstract _getAttributeDefinitions(): AttributeDefinitions;
    abstract _toJson(): any;
}
export default Node;
