import Rect from "../Rect";
import AttributeDefinitions from "../AttributeDefinitions";
import Orientation from "../Orientation";
import DockLocation from "../DockLocation";
import SplitterNode from "./SplitterNode";
import Node from "./Node";
import Model from "./Model";
import DropInfo from "./../DropInfo";
import IDropTarget from "./IDropTarget";
import IDraggable from "./IDraggable";
declare class RowNode extends Node implements IDropTarget {
    static readonly TYPE = "row";
    /** @hidden @internal */
    private static _attributeDefinitions;
    /** @hidden @internal */
    private _drawChildren;
    /** @hidden @internal */
    constructor(model: Model, json: any);
    getWeight(): number;
    getWidth(): number | undefined;
    getHeight(): number | undefined;
    /** @hidden @internal */
    _setWeight(weight: number): void;
    /** @hidden @internal */
    _layout(rect: Rect): boolean;
    /** @hidden @internal */
    _getSplitterBounds(splitterNode: SplitterNode): number[];
    /** @hidden @internal */
    _calculateSplit(splitter: SplitterNode, splitterPos: number): {
        node1Id: string;
        weight1: number;
        pixelWidth1: number;
        node2Id: string;
        weight2: number;
        pixelWidth2: number;
    } | undefined;
    /** @hidden @internal */
    _getDrawChildren(): Array<Node> | undefined;
    /** @hidden @internal */
    _tidy(): void;
    /** @hidden @internal */
    canDrop(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
    /** @hidden @internal */
    drop(dragNode: Node & IDraggable, location: DockLocation, index: number): void;
    /** @hidden @internal */
    _toJson(): any;
    /** @hidden @internal */
    static _fromJson(json: any, model: Model): RowNode;
    isEnableDrop(): boolean;
    /** @hidden @internal */
    _getPrefSize(orientation: Orientation): number | undefined;
    /** @hidden @internal */
    _getAttributeDefinitions(): AttributeDefinitions;
    /** @hidden @internal */
    _updateAttrs(json: any): void;
    /** @hidden @internal */
    private static _createAttributeDefinitions;
}
export default RowNode;
