import Node from "./Node";
import AttributeDefinitions from "../AttributeDefinitions";
import Rect from "../Rect";
import Model from "./Model";
import IDraggable from "./IDraggable";
import { JSMap } from "../Types";
declare class TabNode extends Node implements IDraggable {
    static readonly TYPE = "tab";
    private static _attributeDefinitions;
    private _tabRect?;
    private _extra;
    constructor(model: Model, json: any);
    getTabRect(): Rect | undefined;
    _setTabRect(rect: Rect): void;
    getName(): string;
    getComponent(): string | undefined;
    /**
     * Returns the config attribute that can be used to store node specific data that
     * WILL be saved to the json. The config attribute should be changed via the action Actions.updateNodeAttributes rather
     * than directly, for example:
     * this.state.model.doAction(
     *   FlexLayout.Actions.updateNodeAttributes(node.getId(), {config:myConfigObject}));
     */
    getConfig(): any;
    /**
     * Returns an object that can be used to store transient node specific data that will
     * NOT be saved in the json.
     */
    getExtraData(): JSMap<any>;
    getIcon(): string | undefined;
    isEnableClose(): boolean;
    isEnableDrag(): boolean;
    isEnableRename(): boolean;
    getClassName(): string | undefined;
    isRenderOnDemand(): boolean;
    _setName(name: string): void;
    _layout(rect: Rect): void;
    _delete(): void;
    static _fromJson(json: any, model: Model): TabNode;
    _toJson(): {};
    _updateAttrs(json: any): void;
    _getAttributeDefinitions(): AttributeDefinitions;
    private static _createAttributeDefinitions;
}
export default TabNode;
