import Rect from "../Rect";
import AttributeDefinitions from "../AttributeDefinitions";
import DockLocation from "../DockLocation";
import DropInfo from "./../DropInfo";
import Node from "./Node";
import Model from "./Model";
import TabNode from "./TabNode";
import Orientation from "../Orientation";
import IDraggable from "./IDraggable";
import IDropTarget from "./IDropTarget";
declare class TabSetNode extends Node implements IDraggable, IDropTarget {
    static readonly TYPE = "tabset";
    /** @hidden @internal */
    private static _attributeDefinitions;
    /** @hidden @internal */
    private _contentRect?;
    /** @hidden @internal */
    private _tabHeaderRect?;
    /** @hidden @internal */
    constructor(model: Model, json: any);
    getName(): string | undefined;
    getSelected(): number;
    getSelectedNode(): Node | undefined;
    getWeight(): number;
    getWidth(): number | undefined;
    getHeight(): number | undefined;
    isMaximized(): boolean;
    isActive(): boolean;
    isEnableDeleteWhenEmpty(): boolean;
    isEnableDrop(): boolean;
    isEnableDrag(): boolean;
    isEnableDivide(): boolean;
    isEnableMaximize(): boolean;
    isEnableTabStrip(): boolean;
    getClassNameTabStrip(): string | undefined;
    getClassNameHeader(): string | undefined;
    getHeaderHeight(): number;
    getTabStripHeight(): number;
    /** @hidden @internal */
    _setWeight(weight: number): void;
    /** @hidden @internal */
    _setSelected(index: number): void;
    /** @hidden @internal */
    canDrop(dragNode: Node & IDraggable, x: number, y: number): DropInfo | undefined;
    /** @hidden @internal */
    _layout(rect: Rect): void;
    /** @hidden @internal */
    _remove(node: TabNode): void;
    /** @hidden @internal */
    drop(dragNode: Node & IDraggable, location: DockLocation, index: number): void;
    /** @hidden @internal */
    _toJson(): any;
    /** @hidden @internal */
    _updateAttrs(json: any): void;
    /** @hidden @internal */
    static _fromJson(json: any, model: Model): TabSetNode;
    /** @hidden @internal */
    _getAttributeDefinitions(): AttributeDefinitions;
    /** @hidden @internal */
    _getPrefSize(orientation: Orientation): number | undefined;
    /** @hidden @internal */
    private static _createAttributeDefinitions;
}
export default TabSetNode;
