import * as React from "react";
import TabNode from "../model/TabNode";
import Layout from "./Layout";
/** @hidden @internal */
export interface ITabButtonProps {
    layout: Layout;
    node: TabNode;
    show: boolean;
    selected: boolean;
    height: number;
}
/** @hidden @internal */
export declare class TabButton extends React.Component<ITabButtonProps, any> {
    selfRef?: HTMLDivElement;
    contentWidth: number;
    contentRef?: Element;
    constructor(props: ITabButtonProps);
    onMouseDown(event: Event): void;
    onClick(event: Event): void;
    onDoubleClick(event: Event): void;
    onEndEdit(event: Event): void;
    onClose(event: React.MouseEvent<HTMLDivElement>): void;
    onCloseMouseDown(event: React.MouseEvent<HTMLDivElement>): void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    updateRect(): void;
    onTextBoxMouseDown(event: React.MouseEvent<HTMLInputElement>): void;
    onTextBoxKeyPress(event: React.KeyboardEvent<HTMLInputElement>): void;
    doRename(node: TabNode, newName: string): void;
    render(): JSX.Element;
}
