import * as React from "react";
import TabSetNode from "../model/TabSetNode";
import TabNode from "../model/TabNode";
import Layout from "./Layout";
/** @hidden @internal */
export interface ITabSetProps {
    layout: Layout;
    node: TabSetNode;
}
/** @hidden @internal */
export declare class TabSet extends React.Component<ITabSetProps, any> {
    headerRef?: HTMLDivElement;
    overflowbuttonRef: any;
    toolbarRef?: HTMLDivElement;
    recalcVisibleTabs: boolean;
    showOverflow: boolean;
    showToolbar: boolean;
    constructor(props: ITabSetProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillReceiveProps(nextProps: ITabSetProps): void;
    updateVisibleTabs(): void;
    render(): JSX.Element;
    onOverflowClick(hiddenTabs: Array<{
        name: string;
        node: TabNode;
        index: number;
    }>, event: React.MouseEvent<HTMLDivElement>): void;
    onOverflowItemSelect(item: {
        name: string;
        node: TabNode;
        index: number;
    }): void;
    onMouseDown(event: Event): void;
    onInterceptMouseDown(event: React.MouseEvent<HTMLDivElement>): void;
    onMaximizeToggle(): void;
    onDoubleClick(event: Event): void;
}
